# 分布式系统

## [面试连环炮](/docs/distributed-system/distributed-system-interview.md)

## 系统拆分

* [为什么要进行系统拆分？如何进行系统拆分？拆分后不用 Dubbo 可以吗？](/docs/distributed-system/why-dubbo.md)

## 分布式服务框架

* [说一下 Dubbo 的工作原理？注册中心挂了可以继续通信吗？](/docs/distributed-system/dubbo-operating-principle.md)
* [Dubbo 支持哪些序列化协议？说一下 Hessian 的数据结构？PB 知道吗？为什么 PB 的效率是最高的？](/docs/distributed-system/dubbo-serialization-protocol.md)
* [Dubbo 负载均衡策略和集群容错策略都有哪些？动态代理策略呢？](/docs/distributed-system/dubbo-load-balancing.md)
* [Dubbo 的 SPI 思想是什么？](/docs/distributed-system/dubbo-spi.md)
* [如何基于 Dubbo 进行服务治理、服务降级、失败重试以及超时重试？](/docs/distributed-system/dubbo-service-management.md)
* [分布式服务接口的幂等性如何设计（比如不能重复扣款）？](/docs/distributed-system/distributed-system-idempotency.md)
* [分布式服务接口请求的顺序性如何保证？](/docs/distributed-system/distributed-system-request-sequence.md)
* [如何自己设计一个类似 Dubbo 的 RPC 框架？](/docs/distributed-system/dubbo-rpc-design.md)
* [CAP定理的P是什么](/docs/distributed-system/distributed-system-cap.md)

## 分布式锁

* [Zookeeper 都有哪些应用场景？](/docs/distributed-system/zookeeper-application-scenarios.md)
* [使用 Redis 如何设计分布式锁？使用 Zookeeper 来设计分布式锁可以吗？以上两种分布式锁的实现方式哪种效率比较高？](/docs/distributed-system/distributed-lock-redis-vs-zookeeper.md)

## 分布式事务

* [分布式事务了解吗？你们如何解决分布式事务问题的？TCC 如果出现网络连不通怎么办？XA 的一致性如何保证？](/docs/distributed-system/distributed-transaction.md)

## 分布式会话

* [集群部署时的分布式 Session 如何实现？](/docs/distributed-system/distributed-session.md)

---

## 公众号

GitHub 技术社区 [Doocs](https://github.com/doocs) 旗下唯一公众号「**Doocs开源社区**」​，欢迎扫码关注，**专注分享技术领域相关知识及行业最新资讯**。当然，也可以加我个人微信（备注：GitHub），拉你进技术交流群。

关注「**Doocs开源社区**」公众号，回复 **PDF**，即可获取本项目离线 PDF 文档（283 页精华），学习更加方便！

![](./images/pdf.png)

<table>
    <tr>
      <td align="center" style="width: 200px;">
        <a href="https://github.com/doocs">
          <img src="./images/qrcode-for-doocs.jpg" style="width: 400px;"><br>
          <sub>公众平台</sub>
        </a><br>
      </td>
      <td align="center" style="width: 200px;">
        <a href="https://github.com/yanglbme">
          <img src="./images/qrcode-for-yanglbme.jpg" style="width: 400px;"><br>
          <sub>个人微信</sub>
        </a><br>
      </td>
    </tr>
</table>
